<?php
  //Code by: Can Berk Güder and gnud on StackOverflow
  function thumbnail_box($img, $box_w, $box_h) {
    $new = imagecreatetruecolor($box_w, $box_h);
    if($new === false) {
      return null;
    }
    $fill = imagecolorallocate($new, 255, 255, 255);
    imagefill($new, 0, 0, $fill);

    $hratio = $box_h / imagesy($img);
    $wratio = $box_w / imagesx($img);
    $ratio = min($hratio, $wratio);

    if($ratio > 1.0)
      $ratio = 1.0;

    $sy = floor(imagesy($img) * $ratio);
    $sx = floor(imagesx($img) * $ratio);

    $m_y = floor(($box_h - $sy) / 2);
    $m_x = floor(($box_w - $sx) / 2);

    if(!imagecopyresampled($new, $img,
      $m_x, $m_y,
      0, 0,
      $sx, $sy,
      imagesx($img), imagesy($img))
    ) {
      imagedestroy($new);
      return null;
    }
    
    return $new;
  }
?>